﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Class
Version=9.85
@EndOfDesignText@
#Region Shared Files
#CustomBuildAction: folders ready, %WINDIR%\System32\Robocopy.exe,"..\..\Shared Files" "..\Files"
'Ctrl + click to sync files: ide://run?file=%WINDIR%\System32\Robocopy.exe&args=..\..\Shared+Files&args=..\Files&FilesSync=True
#End Region

'Ctrl + click to export as zip: ide://run?File=%B4X%\Zipper.jar&Args=Project.zip

Sub Class_Globals
	Private Root As B4XView
	Private xui As XUI
	Private SQL1 As SQL
	Private Toast As BCToast
	
	Private GoodAnswer As Int
	Private myQ, myA1, myA2, myA3 As String
	Private lblQuestion As Label
	Private rb1 As RadioButton
	Private rb2 As RadioButton
	Private rb3 As RadioButton
	
	Private qId As Int = 1 'question id
	Private nbrQ As Int 'number of questions
	Private lblNbrQ As Label
	Private score As Int = 0
	Private pnlRadioButton As Panel
	Private myId As Int
	
End Sub

Public Sub Initialize
'	B4XPages.GetManager.LogEvents = True
End Sub

'This event will be called once, before the page becomes visible.
Private Sub B4XPage_Created (Root1 As B4XView)
	Root = Root1
	Root.LoadLayout("MainPage")
	B4XPages.SetTitle(Me, "Quiz")
	
	' If the database does not exist, copy the database
	If Not(File.Exists(xui.DefaultFolder, "quiz.db3")) Then
		File.Copy(File.DirAssets, "quiz.db3", xui.DefaultFolder, "quiz.db3")
	End If
	SQL1.Initialize(xui.DefaultFolder, "quiz.db3", True)
	Toast.Initialize(Root)
	
	nbrQ = SQL1.ExecQuerySingleResult("SELECT count(*) FROM table_quiz") 'number of questions in the db
		
	loadQuestion'(qId)
	
End Sub

Private Sub loadQuestion'(n As Int)
	
	reset_radiobutton
	
	lblNbrQ.Text =  $"Question ${qId} of ${nbrQ}"$
	
	'selection of a random question that has not yet been asked. - view=0
	Dim RS As ResultSet = SQL1.ExecQuery("SELECT * FROM table_quiz where view = 0 ORDER BY Random()")
	
	'if there are no more questions
	If RS.RowCount = 0 Then 
		Toast.Show($"[b]All the questions have already been asked[/b]"$)
		Return
	End If
	
	RS.NextRow
	myId = RS.GetInt("id_question") 'current question id
	myQ = RS.GetString("question").Trim
	myA1 = RS.GetString("answer1").Trim
	myA2 = RS.GetString("answer2").Trim
	myA3 = RS.GetString("answer3").Trim
	GoodAnswer = RS.GetInt("tag")
		
	lblQuestion.Text = myQ
	rb1.Text = myA1
	rb2.Text = myA2
	rb3.Text = myA3
	
	'the question has already been answered. 
	'I set 'view' to 1 so as not to repeat the question a second time
	SQL1.ExecNonQuery("UPDATE table_quiz Set view = 1  WHERE id_question = " & myId & "") 

End Sub


Private Sub btCheck_Click
'	check
	Dim userSelected As Int
	If rb1.Checked Then userSelected = 1
	If rb2.Checked Then userSelected = 2
	If rb3.Checked Then userSelected = 3

	If userSelected = GoodAnswer Then 'compare the answers
		score = score+1
		Toast.Show($"You win [b]Score : ${score} points[/b]"$)
	Else
		Toast.Show($"You lost : [b]Score : ${score} points[/b]"$)
	End If
	
	qId = qId+1 'question id

	If qId <= nbrQ Then
		loadQuestion'(qId) 'next question
	Else
		Sleep(1000)
		Toast.Show($"Completed Quiz. You have a score of [b]${score} points[/b]"$)
	End If
	
	
End Sub

Sub rb_CheckedChange(Checked As Boolean)  'new sub
	For Each rr As RadioButton In pnlRadioButton.GetAllViewsRecursive
		If GoodAnswer = rr.Tag  Then
			SetColorTintList(rr,Colors.Green,Colors.Green,Colors.Gray)
		Else
			SetColorTintList(rr,Colors.Red,Colors.Red,Colors.Gray)
		End If
	Next
End Sub

Private Sub reset_radiobutton
	'rb1.Checked = False
	'rb2.Checked = False
	'rb3.Checked = False
	
	For Each rb As RadioButton In pnlRadioButton.GetAllViewsRecursive
		SetColorTintList(rb,Colors.Gray,Colors.Gray,Colors.Gray)
		rb.Checked = False
	Next
	
End Sub

Sub SetColorTintList(RB As RadioButton,Checked As Int,Enabled As Int,Disabled As Int)

	Dim States(3,1) As Int
	States(0,0) = 16842912   'Checked
	States(1,0) = 16842910    'Enabled
	States(2,0) = -16842910 'Disabled

	Dim Color(3) As Int = Array As Int(Checked,Enabled,Disabled)

	Dim CSL As JavaObject
	CSL.InitializeNewInstance("android.content.res.ColorStateList",Array As Object(States,Color))
	Dim CB1 As JavaObject = RB
	CB1.RunMethod("setButtonTintList",Array As Object(CSL))

End Sub



